<?php
/*
Plugin Name: TS Youtube channel gallery plugin
Plugin URI: http://pro-cod.ru/wp-content/uploads/2013/07/ts-youtube-channel-gallery.zip
Author: TSergey
Author URI: http://pro-cod.ru/
*/

/*ADMIN SETTING FUNCTION*/
function admin_settings() {
	?>
	<div class="wrap">
		<h2>TS Youtube Channel Gallery</h2>
		<form method="post" action="options.php">
		<?php wp_nonce_field('update-options'); ?>
		
		
		<!--<input type="text" name="channel_name" value="<?php //echo get_option('channel_name') ?>" /><br />-->
		<label for="channel_name">Название канала:</label><br/>
		<input type="text" name="channel_name" value="<?php echo get_option('channel_name') ?>" /><br />
		
		<label for="count_video">Количество отображаемых видео:</label><br/>
		<select name="count_video">
		<?
			if (get_option('count_video')!=''){
				for ($i=1;$i<=15;$i++){
					if ($i==get_option('count_video')){
						echo "<option selected>".get_option('count_video')."</option>";
					}else{
						echo "<option>".$i."</option>";
					}
				}
			}else{
				for ($i=1;$i<=15;$i++){
					echo "<option selected>".$i."</option>";
				}
			}
		?>
		</select><br/>
		<!--<input type="text" name="count_video" value="<?php// echo get_option('count_video') ?>" /><br />-->
		
		<input type="hidden" name="page_options" value="channel_name,count_video" />
		<input type="hidden" name="action" value="update" />
		<input type="submit" name="update" value="Сохранить">
		</form>
	</div>
	<? 
} 

/*ADMIN MENU DECLARATION*/
function ts_gallery_admin_menu(){
    add_options_page('TS gallery plugin', 'TS Gallery Plugin', 8, basename(__FILE__), 'admin_settings');
}

/*GET A LINK TO YOUTUBE VIDEO*/
function getVideoUrl ($data) {
    if (preg_match("/<iframe.*?src=\"([^\"]+)\".*?><\/iframe>/i", $data, $matches)) {
        $url = $matches[1];
    }
    if (preg_match("/<object.*?>.*?<param name=\"movie\" value=\"([^\"]+)\"( \/>|><\/param>).*?<\/object>/i", $data, $matches)) {
        $url = $matches[1];
    }
    return $url;
}
/*GET VIDEO PREVIEW*/
function getVideoThumbUrl ($url) {
    if (!is_string($url) || empty($url)) return false;
    $url = str_replace("&amp;", "&", $url);
    $arr = parse_url($url);
    $arr[host] = str_replace('www.', '', $arr[host]);
    $url = "";
    switch ($arr[host]) {
        case 'rutube.ru':
            if (preg_match("/\/tracks\/(.+)\.html/i", $arr[path], $matches)) {
                $xml = simplexml_load_file("http://rutube.ru/cgi-bin/xmlapi.cgi?rt_mode=movie&rt_movie_id=".$matches[1]."&utf=1");
                if ($xml) {
                    $url = (string) $xml->response->movie->thumbnailLink;
                }
            }
            break;
        case 'video.rutube.ru':
            if (preg_match("/\/(.+)/i", $arr[path], $matches)) {
                $s[0] = substr($arr[path], 1, 2);
                $s[1] = substr($arr[path], 3, 2);
                $url = "http://tub.rutube.ru/thumbs/".$s[0]."/".$s[1]."/".$matches[1]."-1-1.jpg";
            }
            //$url = "http://img-1.rutube.ru/thumbs/".$link[0].$link[1]."/".$link[2].$link[3]."/".$link."-2.jpg";
            break;
        case 'youtube.com':
            if (preg_match("/\/(embed|v)\/(.+)\/?/i", $arr[path], $matches)) {
                $url = "http://img.youtube.com/vi/".$matches[2]."/0.jpg";
            }
            break;
        case 'player.vimeo.com':
            if (preg_match("/\/video\/(.+)\/?/i", $arr[path], $matches)) {
                $clip_id = $matches[1];
            }
            $xml = simplexml_load_file('http://vimeo.com/api/v2/video/'.$clip_id.'.xml');
            if ($xml) {
                $url = (string) $xml->video->thumbnail_medium;
            }
            break;
        case 'vimeo.com':
            parse_str($arr[query], $query);
            $clip_id = $query['clip_id'];
            $xml = simplexml_load_file('http://vimeo.com/api/v2/video/'.$clip_id.'.xml');
            if ($xml) {
                $url = (string) $xml->video->thumbnail_medium;
            }
            break;
        default:
            $url = "";
            break;
    }
    return $url;
}
function ts_youtube_gallery_css(){
	//wp_register_style( 'style', plugins_url( '/css/style.css', __FILE__ ));
	wp_enqueue_style('style', plugins_url( '/css/style.css', __FILE__ ));
}
add_action( 'wp_head', 'ts_youtube_gallery_css' );

function videos_counstuct($atts) {
	$channel_name   =  get_option('channel_name');//НАЗВАНИЕ КАНАЛА
	$count          =  get_option('count_video');//КОЛИЧЕСТВО ВИДЕО
	if(get_option('channel_name')!=''){
		if (get_option('count_video')==''){
			$count=5;
		}
		//The output...
		$sxml = simplexml_load_file("http://gdata.youtube.com/feeds/api/users/$channel_name/uploads?max-results=$count");//ПОЛУЧИТЬ ДАННЫЕ С ЮТЬЮБА
		echo "<ul class='ts-slider-video'>";
		foreach ($sxml->entry as $entry) {//РАЗБИВАЕМ ДАННЫЕ
			$vidKey = substr(strrchr($entry->id,'/'),1);
			$linktube="http://www.youtube.com/watch?feature=player_embedded&v=".$vidKey;//ПОЛУЧИТЬ ЗАГОЛОВОК ВИДЕ ССЫЛКИ
			$vidID = $vidKey;
			$url = "http://gdata.youtube.com/feeds/api/videos/". $vidID;
			$doc = new DOMDocument;
			$doc->load($url);
			$title = $doc->getElementsByTagName("title")->item(0)->nodeValue;
			echo "
			<li>
				 <a target='_blank' class='miniature' href='".$linktube."'><img title='".$title."' src='".getVideoThumbUrl('http://www.youtube.com/embed/'.$vidKey)."'></a>
				 <h2><a href='".$linktube."'>".$title."</a></h2>
				 
			</li>
			";
		}
		echo "</ul>";
	}
}

add_shortcode( 'ts-youtube-gallery', 'videos_counstuct' );
add_filter('widget_text', 'do_shortcode');
add_action('admin_menu', 'ts_gallery_admin_menu');

?>